### Method

# Hex Document find_backward_async

#### Declaration

    void
    hex_document_find_backward_async (
      HexDocument* doc,
      gint64 start,
      const char* what,
      size_t len,
      gint64* offset,
      const char* found_msg,
      const char* not_found_msg,
      GCancellable* cancellable,
      GAsyncReadyCallback callback,
      gpointer user_data
    )

#### Description

Non-blocking version of `hex_document_find_backward()`. This is the function that should generally be used by a GUI client to find a string backwards in a `HexDocument`.

#### Parameters

`start`

  Type: `gint64`

  Starting offset byte of the payload to commence the search.

`what`

  Type: An array of `gint8`

  A pointer to the data to search within the `HexDocument`.

  The length of the array is specified in the `len` argument.
  The data is owned by the caller of the method.

`len`

  Type: `size_t`

  Length in bytes of the data to be searched for.

`offset`

  Type: `gint64*`

  Offset of the found string, if the method returns `TRUE`.

  The argument will be set by the function.

`found_msg`

  Type: `const char*`

  Message intended to be displayed by the client if the string is found.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`not_found_msg`

  Type: `const char*`

  Message intended to be displayed by the client if the string is not found.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`cancellable`

  Type: `GCancellable`

  No description available.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`callback`

  Type: `GAsyncReadyCallback`

  Function to be called when the operation is complete.

  The argument can be `NULL`.

`user_data`

  Type: `gpointer`

  No description available.

  The argument can be `NULL`.
  The data is owned by the caller of the method.